/*
   https://classes.soe.ucsc.edu/cmps012a/Winter06/OnToC.pdf
*/



/* Page 1 */

/* hello.c
 * Author - Jane Programmer
 * Purpose - print hello
 */
#include <stdio.h>

int main(void)
{
   printf("Hello, world!\n");
   return 0;
}



/* Page 5 */

/* basicSyntax.c
 * Author - Charlie McDowell
 * Purpose - demonstrate local variables,
 * built-in types, if-else, and loops
 */
#include <stdio.h>

int main(void)
{
   int num1 = 4, num2 = 10, i;
   double ratio;

   for(i = 1; i <= num1; i++)
      printf("%d ",i);
   printf("\n");

   while(num1 > 0)
   {
      printf("%d ",num1);
      num1--;
   }
   printf("\n");

   if(num1 != 0)
      ratio = num2 / num1;
   else
      ratio = num2 / 3.0;
   printf("%f\n",ratio);

   return 0;
}



/* Page 9 */

/* printfExample.c
 * Author - Charlie McDowell
 * Purpose - simple use of printf
 */
#include <stdio.h>

int main(void)
{
   int intVal = 10;
   double doubleVal = 1.234;

   printf("intVal = %d, doubleVal = %f\n", intVal, doubleVal);

   return 0;
}




/* Page 13 */

/* printf.c
 * Author - Charlie McDowell
 * Purpose - demonstrate a few formatting possibilities
 */
#include <stdio.h>

int main(void)
{
   int anInt = 123;
   float aFloat = 1.234567;

   printf("1234567890,1234567890\n");
   printf("%+10.4d,%-+10.4d\n", anInt, anInt);
   printf("%010d,%#x\n", anInt, anInt);
   printf("%-10.4f,%-+10.7f\n", aFloat, aFloat);

   return 0;
}



/* Page 14 */

/* scanfExample.c
 * Author - Charlie McDowell
 * Purpose - simple use of scanf
 */
#include <stdio.h>

int main(void)
{
   int intVal;
   float floatVal;

   scanf("%d", &intVal);
   scanf("%f", &floatVal);

   printf("intVal = %d, floatVal = %f\n", intVal, floatVal);

   return 0;
}





/* Page 20 */

/* min.c
 * Author - Charlie McDowell
 * Purpose - simple function definition/call
 */
#include <stdio.h>

int min(int x, int y)
{
   if(x < y)
      return x;
   else
      return y;
}

int main(void)
{
   int num1, num2;

   printf("Enter two integers.\n");
   scanf("%d%d", &num1, &num2);

   printf("The smaller is %d\n", min(num1, num2));

   return 0;
}





/* Page 21 */

/* min2.c
 * Author - Charlie McDowell
 * Purpose - simple function definition/call
 * using a prototype to allow main() to be first
 */
#include <stdio.h>

int min(int x, int y);

int main(void)
{
   int num1, num2;

   printf("Enter two integers.\n");
   scanf("%d%d", &num1, &num2);

   printf("The smaller is %d\n", min(num1, num2));

   return 0;
}

int min(int x, int y)
{
   if(x < y)
      return x;
   else
      return y;
}




/* Page 22 */

/* pointer.c
 * Author - Charlie McDowell
 * Purpose - introduce pointers
 */
#include <stdio.h>

int main(void)
{
   int x = 123, y;
   int *pointerOne, *pointerTwo;

   pointerOne = &x;
   y = *pointerOne;
   printf("x = %d, y = %d\n", x, y);

   pointerTwo = pointerOne;
   *pointerTwo = 99;
   printf("x = %d, y = %d\n", x, y);

   pointerTwo = &y;
   printf("*pointerOne = %d, *pointerTwo = %d\n", *pointerOne, *pointerTwo);

   printf("pointerOne = %u, pointerTwo = %u\n",    pointerOne,  pointerTwo);
   return 0;
}




/* Page 26 */

/* swap.c
 * Author - Charlie McDowell
 * Purpose - call-by-reference
 */
#include <stdio.h>

void swap(int *x_p, int *y_p)
{
   int temp;

   temp = *x_p;
   *x_p = *y_p;
   *y_p = temp;
}

int main(void)
{
   int num1, num2;

   printf("Enter two integers.\n");
   scanf("%d%d", &num1, &num2);
   printf("num1 = %d, num2 = %d\n", num1, num2);

   swap(&num1, &num2);

   printf("num1 = %d, num2 = %d\n", num1, num2);
   return 0;
}





/* Page 34 */

/* arrayBounds.c
 * Author - Charlie McDowell
 * Purpose - exceed array bounds without an error
 */
#include <stdio.h>

int main(void)
{
   int smallArray[10];
   int i;

   for(i = 0; i < 10; i++)
      smallArray[i] = i*10;

   for(i = 0; i <= 10; i++)
      printf("%d\n",smallArray[i]);

   return 0;
}




/* Page 36 */

/* arrayParams.c
 * Author - Charlie McDowell
 * Purpose - passing arrays as parameters
 */
#include <stdio.h>

void fillIt(int someArray[]);

int main(void)
{
   int smallArray[10];
   int i;

   fillIt(smallArray);

   for(i = 0; i < 10; i++)
      printf("%d ",smallArray[i]);
   printf("\n");

   return 0;
}

void fillIt(int someArray[])
{
   int i;

   for(i = 0; i < 10; i++)
      someArray[i] = 100 + i;
}



/* Page 38 */

/* arrayParams2.c
 * Author - Charlie McDowell
 * Purpose - show array is really a pointer
 */
#include <stdio.h>

void fillIt(int *someArray);

int main(void)
{
   int smallArray[10];
   int i;

   fillIt(smallArray);

   for(i = 0; i < 10; i++)
      printf("%d ",smallArray[i]);
   printf("\n");

   return 0;
}

void fillIt(int *someArray)
{
   int i;

   for(i = 0; i < 10; i++)
   {
      *someArray = 100 + i;
      someArray++;
   }
}




/* Page 40 */

/* dynamicArray.c
 * Author - Charlie McDowell
 * Purpose - create an array dynamically
 */
#include <stdio.h>
#include <stdlib.h>

int main(void)
{
   int *array_p;
   int size, i;

   printf("How many elements will be in the array?\n");
   scanf("%d", &size);

   array_p = calloc(size, sizeof(int));

   for(i = 0; i < size; i++)
   {
      array_p[i] = 100 + i;
   }

   for(i = 0; i < size; i++)
      printf("%d ", array_p[i]);
   printf("\n");
   return 0;
}





/* Page 45 */

/* strings.c
 * Author - Charlie McDowell
 * Purpose - show strings as arrays of char
 */
#include <stdio.h>

int main(void)
{
   char strOne[] = {'s','t','r','i','n','g',' ','o','n','e','\0'};
   char *char_p;
   int i;

   printf("%s\n", strOne);

   for(i = 0; strOne[i] != '\0'; i++)
      printf("%c,", strOne[i]);
   printf("\n");

   for(char_p = strOne; *char_p != '\0'; char_p++)
      printf("%c,", *char_p);
   printf("\n");

   return 0;
}




/* Page 49 */

/* stringLib.c
 * Author - Charlie McDowell
 * Purpose - demo some standard string functions
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_S2 100

int main(void)
{
   char *s1 = "String one";
   char *s2 = calloc(MAX_S2, sizeof(char));
   char *s3;

   printf("The length of \"%s\" is %d\n", s1, strlen(s1));

   strncpy(s2, "Testing", MAX_S2);
   strncat(s2, " 1 2 3", MAX_S2 - strlen(s2));
   printf("s2 contains:%s\n", s2);

   s3 = strchr(s1, 'g');
   printf("s3 is now %s\n", s3);

   s3 = strstr(s1, "tr");
   printf("s3 is now %s\n", s3);

   printf("comparing %s and %s gives %d\n",
           s1, s2, strncmp(s1, s2, MAX_S2));
   printf("comparing %s and %s gives %d\n",
           s2, s1, strncmp(s2, s1, MAX_S2));
   printf("comparing %s and String one gives %d\n",
           s1, strcmp(s1, "String one"));

   return 0;
}




/* Page 53 */

/* readingStrings.c
 * Author - Charlie McDowell
 * Purpose - reading strings with scanf()
 */
#include <stdio.h>
#include <strings.h>

int main(void)
{
   char strOne[100];
   int status;

   strOne[0] = '\0'; // initialize to the empty string
   printf("Enter a sentence. End with a period.\n");

   status = scanf("%99s", strOne);
   while(status == 1 && strOne[strlen(strOne)-1] != '.')
   {
      printf("%s\n", strOne);
      status = scanf("%99s", strOne);
   }
   printf("%s\n", strOne);

   return 0;
}




/* Page 58 */

/* structAssignment.c
 * Author - Charlie McDowell
 * Purpose - demo creating a new type
 */
#include <stdio.h>
#include <strings.h>

#define NAME_SIZE 80

typedef struct {
   char last[NAME_SIZE];
   char first[NAME_SIZE];
   double gpa;
   int startYear;
} student_t;

int main(void)
{
   student_t studentOne, studentTwo;

   studentOne.gpa = 3.5;
   studentOne.startYear = 2000;
   strncpy(studentOne.first, "Jane", NAME_SIZE);
   strncpy(studentOne.last, "Programmer", NAME_SIZE);

   studentTwo = studentOne; //field by field assignment
   studentTwo.gpa = 3.45;
   strncpy(studentTwo.first, "John", NAME_SIZE);

   printf("%s, %s: gpa:%f, start year:%d\n",
           studentOne.last, studentOne.first,
           studentOne.gpa, studentOne.startYear);

   printf("%s, %s: gpa:%f, start year:%d\n",
           studentTwo.last, studentTwo.first,
           studentTwo.gpa, studentTwo.startYear);

   return 0;
}





/* Page 62 */

/* student.c
 * Author - Charlie McDowell
 * Purpose - passing structs to functions
 */
#include <stdio.h>
#include <strings.h>

#define NAME_SIZE 80

typedef struct {
   char last[NAME_SIZE];
   char first[NAME_SIZE];
   double gpa;
   int startYear;
} student_t;

void printRecord(student_t student);
student_t readRecord();

int main(void)
{
   student_t student;

   student = readRecord();
   printRecord(student);
   return 0;
}

void printRecord(student_t student)
{
   printf("%s, %s: gpa:%f, start year:%d\n",
           student.last, student.first,
           student.gpa, student.startYear);
}

student_t readRecord()
{
   student_t record;

   record.gpa = 3.5;
   record.startYear = 2000;
   strncpy(record.first, "Jane",NAME_SIZE);
   strncpy(record.last, "Programmer",NAME_SIZE);
   return record;
}





/* Page 66 */

/* structByValue.c
 * Author - Charlie McDowell
 * Purpose - show that structs are copied
 */
#include <stdio.h>
#include <strings.h>

#define NAME_SIZE 80

typedef struct {
   char last[NAME_SIZE];
   char first[NAME_SIZE];
   double gpa;
   int startYear;
} student_t;

void printRecord(student_t student);
void readRecord(student_t student);

int main(void)
{
   student_t student;

   // initialize all fields to null string or zero
   student.last[0] = '\0';
   student.first[0] = '\0';
   student.gpa = 0;
   student.startYear = 0;

   readRecord(student);
   printRecord(student);
   return 0;
}

void printRecord(student_t student)
{
   printf("%s, %s: gpa:%f, start year:%d\n",
           student.last, student.first,
           student.gpa, student.startYear);
}

void readRecord(student_t record)
{
   record.gpa = 3.5;
   record.startYear = 2000;
   strncpy(record.first, "Jane",NAME_SIZE);
   strncpy(record.last, "Programmer",NAME_SIZE);
}





/* Page 70 */

/* struct.c
 * Author - Charlie McDowell
 * Purpose - demo creating a new type
 */
#include <stdio.h>
#include <strings.h>

#define NAME_SIZE 80

typedef struct {
   char last[NAME_SIZE];
   char first[NAME_SIZE];
   double gpa;
   int startYear;
} student_t;

void printRecord(student_t student);
void readRecord(student_t *record_p);

int main(void)
{
   student_t student;

   readRecord(&student);
   printRecord(student);

   return 0;
}

void printRecord(student_t student)
{
   printf("%s, %s: gpa:%f, start year:%d\n",
           student.last, student.first, student.gpa,
           student.startYear);
}

void readRecord(student_t *record_p)
{
   (*record_p).gpa = 3.5;
   (*record_p).startYear = 2000;
   strncpy((*record_p).first, "Jane",NAME_SIZE);
   strncpy((*record_p).last, "Programmer",NAME_SIZE);
}





/* Page 72 */

/* structPointer2.c
 * Author - Charlie McDowell
 * Purpose - structure pointer assignment
 */
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

#define NAME_SIZE 80

typedef struct {
   char last[NAME_SIZE];
   char first[NAME_SIZE];
   double gpa;
   int startYear;
} student_t;

int main(void)
{
   student_t *studentOne_p, *studentTwo_p;

   studentOne_p = (student_t *)malloc(sizeof(student_t));
   studentOne_p->gpa = 3.5;
   studentOne_p->startYear = 2000;
   strncpy(studentOne_p->first, "Jane", NAME_SIZE);
   strncpy(studentOne_p->last, "Programmer",NAME_SIZE);

   studentTwo_p = studentOne_p; // pointer assignment

   studentTwo_p->gpa = 3.45;
   strncpy(studentTwo_p->first, "John", NAME_SIZE);

   printf("%s, %s: gpa:%f, start year:%d\n",
           studentOne_p->last, studentOne_p->first,
           studentOne_p->gpa, studentOne_p->startYear);

   printf("%s, %s: gpa:%f, start year:%d\n",
           studentTwo_p->last, studentTwo_p->first,
           studentTwo_p->gpa, studentTwo_p->startYear);

   return 0;
}





/* Page 80 */

/* fileCopy.c
 * Author - Charlie McDowell
 * Purpose - Demonstratie text file I/O by copying one
 *           file to another. The program also uses command
 *           line arguments.
 */
#include <stdio.h>

void copy(FILE* in, FILE* out);

int main(int argc, char* argv[])
{
   FILE* in_file;
   FILE* out_file;

   if(argc != 3)
   {
      printf("Usage: fileCopy inputFile outputFile\n");
      exit(1);
   }

   in_file = fopen(argv[1],"r");
   if(in_file == NULL)
   {
      fprintf(stderr, "ERROR: couldn't open %s for reading\n", argv[1]);
      exit(1);
   }

   out_file = fopen(argv[2],"w");
   if(out_file == NULL)
   {
      fprintf(stderr, "ERROR: couldn't open %s for writing\n", argv[2]);
      exit(1);
   }

   copy(in_file, out_file);

   return 0;
}

#define BUF_SIZE 200

void copy(FILE* in, FILE* out)
{
   char buffer[BUF_SIZE];

   while(fgets(buffer, BUF_SIZE, in) != NULL)
   {
      fprintf(out,"%s",buffer);
   }
}





/* Page 85 */

/* fileMain.c
 * Author - Charlie McDowell
 * Purpose - Demonstratie separate compilation and
 *           header files using a simple stack implementation.
 */
#include <stdio.h>
#include "stack.h"

int main(void)
{
   stack_t* myStack = newStack();

   push(myStack, 123);
   push(myStack, 99);
   push(myStack, 4444);
   while(!empty(myStack))
   {
      int value;
      value = pop(myStack);
      printf("popped: %d\n", value);
   }
}




/* Page 86 */

/* stack.h
 * Author - Charlie McDowell
 * Purpose - A header file for a stack containing
 *           type declarations and function prototypes.
 */
#include <stdio.h>

typedef struct stackElem {
   int value;
   struct stackElem* next_p;
} stackElem_t;

typedef struct {
   stackElem_t* top_p;
} stack_t;

int pop(stack_t* stack_p);
void push(stack_t* stack_p, int value);
int top(stack_t* stack_p);
stack_t* newStack();
int empty(stack_t* stack_p);




/* Page 87 */

/* stack.c
 * Author - Charlie McDowell
 * Purpose - A simple integer stack implementation.
 *           This implementation uses a linked list.
 */
#include "stack.h"

stack_t* newStack()
{
   stack_t* result = (stack_t *)malloc(sizeof(stack_t));
   result->top_p = NULL;
   return result;
}

int pop(stack_t* stack_p)
{
   if(stack_p == NULL || stack_p->top_p == NULL)
   {
      fprintf(stderr, "ERROR: tried to pop an empty stack\n");
      exit(1); // abort the program
   }
   else
   {
      int result;
      stackElem_t* result_elem;
      result_elem = stack_p->top_p;
      result = result_elem->value;
      stack_p->top_p = result_elem->next_p;
      free(result_elem);
      return result;
   }
}

void push(stack_t* stack_p, int value)
{
   stackElem_t* temp =
   (stackElem_t *)malloc(sizeof(stackElem_t));
   temp->value = value;
   temp->next_p = stack_p->top_p;
   stack_p->top_p = temp;
}

int top(stack_t* stack_p)
{
   if(stack_p == NULL || stack_p->top_p == NULL)
   {
      fprintf(stderr, "ERROR: tried to examine top of empty stack\n");
      exit(1); // abort the program
   }
   else
      return stack_p->top_p->value;
}

int empty(stack_t* stack_p)
{
   return (stack_p->top_p == NULL);
}
